/*
 * Newt-Puzzle
 * Copyright (C) Aude Jaulent 2008, 2009 <elderme@tuxfamily.org>
 * 
 * Newt-Puzzle is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Newt-Puzzle is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _COLOR_H_
#define _COLOR_H_
 
class Color
{
public:
	float r,g,b,a;

	/* there are 14 predefined colours in Newt-Puzzle :
	  1: red
 	  2: orange
	  3: yellow
	  4: 
	  5: green
	  6: 
	  7: 
	  8: 
	  9: blue
	 10: 
	 11: 
	 12: 
	 13: black
	 14: white
		 
	coeff is a coefficient between -1 and 1
	if coeff is negative, the colour will be darker,
	*/ 		
	Color(int numColor, float coeff, float alpha);
	Color();
	Color(float red, float green, float blue, float alpha);
	~Color();
	
	void setNumColor(int numColor);
	void applyCoeff(float coeff);	
		
	inline operator float* () {
		return &r;
	}
	inline operator const float* () const {
		return &r;
	}
	
	static const Color WHITE;
	static const Color BLACK;
		
};

#endif // _COLOR_H_
