/*
 * Newt-Puzzle
 * Copyright (C) Aude Jaulent 2008, 2009 <elderme@tuxfamily.org>
 * 
 * Newt-Puzzle is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Newt-Puzzle is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _FOG_H_
#define _FOG_H_

#include "glUtil.h"
#include "color.h"

class Fog
{
public:
	Fog(GLint mode, GLfloat density, GLfloat start, GLfloat end, int numColor);
	Fog(GLint mode, GLfloat density, GLfloat start, GLfloat end, int numColor, float coeff);
	~Fog();
		
	void setColor(int numColor);
	void setColor(int numColor, float coeff);
		
	Color getColor();
		
	void activate();
	void release();
	
private:
    GLint mMode;
    GLfloat mDensity;
    GLfloat mStart;
    GLfloat mEnd;
    Color mColor;
		
};

#endif // _FOG_H_
