/*
 * Newt-Puzzle
 * Copyright (C) Aude Jaulent 2008, 2009 <elderme@tuxfamily.org>
 * 
 * Newt-Puzzle is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Newt-Puzzle is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _SPHERE_H_
#define _SPHERE_H_

#include "../newtEngine/mesh.h"
#include "../newtEngine/entity.h"


class SphereMesh : public Mesh
{
public:
	SphereMesh(float radius, int nbPhi, int nbLambda, bool inside);
	~SphereMesh();
		
	void initFirstParams();
		
	void createVertices(Vector3 *ptr);
	void createColors(Color *ptr);
	void createNormals(Vector3 *ptr);
	void createTexCoords(GLfloat *ptr);
	void createFogCoords(GLfloat *ptr);		
	void createTangents(Vector3 *ptr);	
		
	void createIndices(int numArray, GLuint *ptr);			

protected:
	float mRadius;
	int mNbPhi;
	int mNbLambda;
	bool mInside;
};
	

class SphereWithPosition : public EntityWithPosition
{
public:
	SphereWithPosition(float radius, int nbPhi, int nbLambda, bool inside, Material *material, Vector3 center, Vector3 rotAxis, float angle);
	~SphereWithPosition();
	
};

#endif // _SPHERE_H_
